      SUBROUTINE DE18D(F,M,IORDER,XN,YN,DYN,HMIN,EPS,P,H,X,YX,Z,DF,
     1                 RFN,RF,R,IERR)
         INTEGER IERR,IORDER,M
         DOUBLE PRECISION DF,DYN,EPS,H,HMIN,P,R,RF,RFN,X,XN,YN,YX,Z
         DIMENSION DF(M,5),DYN(M),R(M),RF(M),RFN(M),YN(M),YX(M),Z(M)
         EXTERNAL UTDE17
         INTEGER I
         DOUBLE PRECISION CFNT1,CFNT2,COEF,DABS,HALF,RH,RH1,TWO
         LOGICAL BHMIN
         DIMENSION COEF(5)
         DATA HALF,TWO,CFNT1,CFNT2/0.5D0,2.D0,0.0833333333333D0,
     1        1.125D0/,COEF(1),COEF(2),COEF(3),COEF(4),COEF(5)
     2        /6.D0,1.5D0,0.233333333333D0,0.141666666667D0,12.D0/
       IERR = 0
       BHMIN = .FALSE.
       CALL F(XN,YN,RFN,M)
       RH = CFNT1*H
       RH1 = CFNT2*H
       DO 10 I = 1, M
          RFN(I) = RH*RFN(I)
   10  CONTINUE
   20  CONTINUE
       DO 30 I = 1, M
          R(I) = DYN(I) + COEF(1)*RFN(I)
C  ************  BCEHE Y1  **********
          YX(I) = YN(I) + H*R(I)
   30  CONTINUE
       X = XN + H
       CALL F(X,YX,DF(1,1),M)
       DO 40 I = 1, M
          DF(I,1) = RH*DF(I,1)
          DF(I,2) = DF(I,1) - RFN(I)
          Z(I) = R(I) + COEF(5)*DF(I,1)
C  **********  BCEHE Y2  **********
          YX(I) = YX(I) + H*Z(I)
   40  CONTINUE
       X = X + H
       CALL F(X,YX,RF,M)
       DO 50 I = 1, M
          RF(I) = RH*RF(I)
          RF(I) = RF(I) - DF(I,1)
          DF(I,3) = RF(I) - DF(I,2)
          RF(I) = DF(I,2) - DF(I,3)
          Z(I) = R(I) + TWO*RF(I) + COEF(2)*DF(I,3)
C  **********  BCEHE Y1  **********
          YX(I) = YN(I) + H*Z(I)
   50  CONTINUE
       X = XN + H
       CALL F(X,YX,DF(1,1),M)
       DO 60 I = 1, M
          DF(I,1) = RH*DF(I,1)
          DF(I,2) = DF(I,1) - RFN(I)
          Z(I) = Z(I) + COEF(5)*DF(I,1) + DF(I,3)
C  **********  BCEHE Y2  **********
          YX(I) = YX(I) + H*Z(I)
   60  CONTINUE
       X = X + H
       CALL F(X,YX,RF,M)
       DO 70 I = 1, M
          RF(I) = RH*RF(I)
          DF(I,3) = RF(I) - DF(I,1)
          DF(I,4) = DF(I,3) - DF(I,2)
          Z(I) = Z(I) + COEF(5)*RF(I) + DF(I,4)
C  **********  BCEHE Y3  **********
          YX(I) = YX(I) + H*Z(I)
   70  CONTINUE
       X = X + H
       CALL F(X,YX,DF(1,5),M)
       DO 80 I = 1, M
          DF(I,5) = RH*DF(I,5)
          RF(I) = DF(I,5) - RF(I)
          DF(I,3) = RF(I) - DF(I,3)
          Z(I) = Z(I) + COEF(5)*DF(I,5) + DF(I,3)
C  **********  BCEHE Y4  **********
          YX(I) = YX(I) + H*Z(I)
   80  CONTINUE
       X = X + H
       CALL F(X,YX,Z,M)
       DO 90 I = 1, M
          DF(I,5) = RH*Z(I) - DF(I,5)
          DF(I,5) = DF(I,5) - RF(I)
          RF(I) = DF(I,3) - DF(I,4)
          DF(I,5) = DF(I,5) - DF(I,3)
          DF(I,5) = DF(I,5) - RF(I)
          DF(I,3) = DF(I,4) - RF(I) + DF(I,5)
          DF(I,4) = RF(I) - TWO*DF(I,5)
C  **********  AKOHEHO BCEHE POHTA  **********
          Z(I) = R(I) + TWO*DF(I,2) - HALF*DF(I,3) - COEF(3)*DF(I,4)
     1            - COEF(4)*DF(I,5)
C  **********  BCEHE Y1  **********
          YX(I) = YN(I) + H*Z(I)
          R(I) = RH1*DF(I,5)
          IF (DABS(YX(I)) .GT. P) R(I) = R(I)/YX(I)
          IF (DABS(R(I)) .GT. EPS) GO TO 100
   90     CONTINUE
          X = XN + H
          GO TO 140
  100  CONTINUE
       IF ( .NOT. BHMIN) GO TO 110
          IERR = 65
          GO TO 140
  110  CONTINUE
       H = HALF*H
       IF (DABS(H) .GT. DABS(HMIN)) GO TO 120
          H = DSIGN(HMIN,H)
          BHMIN = .TRUE.
  120  CONTINUE
       RH = HALF*RH
       RH1 = HALF*RH1
       DO 130 I = 1, M
          RFN(I) = HALF*RFN(I)
  130  CONTINUE
       GO TO 20
  140  CONTINUE
       IF (IERR .NE. 0) CALL UTDE17(IERR,18)
       RETURN
      END
