      SUBROUTINE DE48D(F,M,JSTART,HMIN,HMAX,EPS,P,YX,X,Z,H,BUL,DELTY,
     1                 DF,RFN,RF,YP,ZP,IERR)
         INTEGER IERR,JSTART,M
         DOUBLE PRECISION DELTY,DF,EPS,H,HMAX,HMIN,P,RF,RFN,X,YP,YX,Z,
     1                    ZP
         LOGICAL BUL
         DIMENSION DELTY(M),DF(M,5),RF(M),RFN(M),YP(M),YX(M),Z(M),
     1             ZP(M)
         COMMON /COM48D/HOLD,HNEW,XOLD,ISTART
         INTEGER I,IN,ISTART,JER,K,KP1
         DOUBLE PRECISION ALP,CFNT1,CFNT2,CFNT3,CFNT4,CFNT5,DABS,
     1                    DSIGN,EPS1,EPS2,HALF,HNEW,HOLD,RH,TWO,XOLD
         LOGICAL BCOR,BHMIN
         DATA HALF,TWO/0.5D0,2.D0/,CFNT1,CFNT2,CFNT3,CFNT4,CFNT5
     1        /0.08333333333333333D0,0.015625D0,12.D0,20.D0,-0.05D0/
       EPS1 = CFNT4*EPS
       EPS2 = CFNT2*EPS
       BHMIN = .FALSE.
       ISTART = 1
       IF (JSTART .GE. 0) GO TO 50
          IF (IERR .LT. 65) GO TO 20
             IF (DABS(H) .LT. DABS(HNEW)) GO TO 10
                H = HNEW*HALF
   10        CONTINUE
             IERR = 0
             GO TO 80
   20  CONTINUE
       IF (HOLD*TWO .EQ. HNEW) CALL DE48DP(M,5,HALF,DF,Z,ZP)
       DO 40 K = 1, 4
          KP1 = K + 1
          DO 30 I = 1, M
             DF(I,K) = DF(I,K) - DF(I,KP1)
   30     CONTINUE
   40  CONTINUE
       ALP = H/HOLD
       IERR = 0
       GO TO 90
   50  CONTINUE
       XOLD = X
       DO 60 I = 1, M
          YP(I) = YX(I)
          ZP(I) = Z(I)
   60  CONTINUE
       IERR = 0
       IF (JSTART .GT. 0) GO TO 70
          CALL F(X,YX,RF,M)
C  **********  BOHEHE CAMOO EPBOO AA, T.E. PAOH  **********
          CALL DE18D(F,M,5,XOLD,YP,ZP,HMIN,EPS,P,H,X,YX,Z,DF,RFN,RF,
     1               DELTY,JER)
          IF (JER .NE. 0) IERR = 66
          HOLD = H
          GO TO 280
   70  CONTINUE
       IF (H .EQ. HNEW) GO TO 100
   80  CONTINUE
       ALP = H/HNEW
   90  CONTINUE
       CALL DE48DP(M,5,ALP,DF,ZP,Z)
  100  CONTINUE
       DO 110 I = 1, M
          RF(I) = DF(I,3) + DF(I,4)
          Z(I) = ZP(I) + CFNT3*DF(I,1) + RF(I)
          YX(I) = YP(I) + H*Z(I)
          DELTY(I) = -RF(I) - DF(I,1) - DF(I,2)
  110  CONTINUE
       RH = CFNT1*H
       IN = 1
       X = XOLD + H
  120  CONTINUE
       BCOR = .TRUE.
       CALL F(X,YX,RF,M)
       DO 140 I = 1, M
          RF(I) = RH*RF(I)
C  **********  BEHA KOPPEK  POMEYTOHO EPEMEHHO Z  *****
          DELTY(I) = DELTY(I) + RF(I)
          Z(I) = Z(I) + DELTY(I)
C  **********  BEHA KOPPEK  PEEH YX  **********
          DELTY(I) = H*DELTY(I)
          YX(I) = YX(I) + DELTY(I)
          IF (DABS(YX(I)) .GT. P) DELTY(I) = DELTY(I)/YX(I)
  130     CONTINUE
          IF (DABS(DELTY(I)) .GT. EPS) BCOR = .FALSE.
  140  CONTINUE
       IF (BCOR) GO TO 210
          IF (IN .EQ. 2) GO TO 170
             DO 150 I = 1, M
                IF (DABS(DELTY(I)) .GT. EPS1) GO TO 170
  150           CONTINUE
                IN = IN + 1
                DO 160 I = 1, M
                   DELTY(I) = -RF(I)
  160           CONTINUE
C  **********  EM HA BOHEHE BTOPO KOPPEK  **********
                GO TO 120
  170     CONTINUE
          IF ( .NOT. BHMIN) GO TO 180
             IERR = 65
             GO TO 280
C  **********  EEHE AA OOAM  **********
  180  CONTINUE
       H = HALF*H
       BUL = .FALSE.
       IF (DABS(H) .GT. DABS(HMIN)) GO TO 190
          RH = DSIGN(HMIN,H)
          ALP = RH*HALF/H
          H = RH
          BHMIN = .TRUE.
          GO TO 200
  190  CONTINUE
       ALP = HALF
  200  CONTINUE
       CALL DE48DP(M,5,ALP,DF,ZP,Z)
C  **********  EM HA OBTOPEHE OOBHHOO AA  **********
       GO TO 100
C  **********  TOHOCT OCTHYTA OCE OHO  BYX KOPPEK  *****
  210  CONTINUE
       CALL F(X,YX,RF,M)
       DO 220 I = 1, M
          RF(I) = RH*RF(I)
  220  CONTINUE
       CALL DE28DS(M,5,RF,DF,DELTY)
       HOLD = H
       DO 230 I = 1, M
          DELTY(I) = CFNT5*DF(I,5)
C  **********  YTOHEHE PEEH  POMEYTOHO EPEMEHHO  **********
          Z(I) = Z(I) + DELTY(I)
          DELTY(I) = H*DELTY(I)
          YX(I) = YX(I) + DELTY(I)
  230  CONTINUE
  240  CONTINUE
       DO 250 I = 1, M
          IF (DABS(YX(I)) .GT. P) DELTY(I) = DELTY(I)/YX(I)
          IF (DABS(DELTY(I)) .GT. EPS2) GO TO 280
  250     CONTINUE
C  **********  YBOEHE AA  **********
          H = TWO*H
          ISTART = 2
          IF (DABS(H) .LE. DABS(HMAX)) GO TO 260
             ALP = DSIGN(HMAX,H)*TWO/H
             H = DSIGN(HMAX,H)
             GO TO 270
  260  CONTINUE
       ALP = TWO
  270  CONTINUE
       CALL DE48DP(M,5,ALP,DF,Z,ZP)
  280  CONTINUE
       IF (IERR .NE. 0) CALL UTDE17(IERR,48)
       JSTART = 1
       HNEW = H
       RETURN
      END
